import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
/**
 * Write a description of class MessageBox here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MessageBox  extends Actor
{
    /**
     * Act - do whatever the MessageBox wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private String display;
    private String line1="";
    private String line2="";
    private String line3="";
    private boolean confirm;
    private int timer=-1;
    private boolean done=false;
    
    public MessageBox(){
        this("",true);
    }
    
    public MessageBox(String text, boolean okay){
        display = text;
        confirm = okay;
        if(!okay){
            timer=60;
        }
        splitStrings();
        display();
    }
    
    public void act() 
    {
        if(!confirm){
            if(timer==0){
                done=true;
            }
            else{
                timer--;
            }
        }
        else{
            if(Greenfoot.mousePressed(this)){
                done=true;
            }
        }
        if(done){
            getWorld().removeObject(this);
        }
    }
    
    private void splitStrings(){
        char[] carray = display.toCharArray();
        char[] cline1 = new char[35];
        char[] cline2 = new char[35];
        char[] cline3 = new char[35];
        if(carray.length>35){
            for(int i=0;i<35;i++){
                cline1[i]=carray[i];
            }
            line1 = String.copyValueOf(cline1);
            if(carray.length-35>35){
                for(int i=0;i<35;i++){
                    cline2[i]=carray[i+35];
                }
                line2 = String.copyValueOf(cline2);
                if(carray.length-70>35){
                    for(int i=0;i<35;i++){
                        cline3[i]=carray[i+70];
                    }
                    line3 = String.copyValueOf(cline3);
                }
                else{
                    cline3 = new char[carray.length-70];
                    for(int i=0;i<carray.length-70;i++){
                        cline3[i]=carray[i+70];
                    }
                    line3 = String.copyValueOf(cline3);
                }
            }
            else{
                cline2 = new char[carray.length-35];
                for(int i=0;i<carray.length-35;i++){
                    cline2[i]=carray[i+35];
                }
                line2 = String.copyValueOf(cline2);
            }
        }
        
    }
    
    public boolean done(){
        return done;
    }
    
    private void display(){
        GreenfootImage img = new GreenfootImage(375, 187);
        img.setColor(new Color(0,127,0,191));
        img.fill();
        img.setFont(new Font("Comic Sans MS", Font.BOLD, 16));
        if(line1==""){
            img.setColor(Color.BLACK);
            img.drawString(display,6,61);
            img.setColor(Color.WHITE);
            img.drawString(display,5,60);
        }
        else{
            img.setColor(Color.BLACK);
            img.drawString(line1,6,61);
            img.drawString(line2,6,81);
            img.drawString(line3,6,101);
            img.setColor(Color.WHITE);
            img.drawString(line1,5,60);
            img.drawString(line2,5,80);
            img.drawString(line3,5,100);
        }
        setImage(img);
    }
}
