import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Meter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Meter  extends Actor
{
    /**
     * Act - do whatever the Meter wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private int max_cap;
    private int current;
    
    public Meter(int max){
        max_cap = max;
        current=0;
        updateImage();
    }
    
    public void updateCurrent(int new_val){
        current=new_val;
        if(!maxed()){
            updateImage();
        }
    }
    
    public boolean maxed(){
        return current>max_cap;
    }
    
    public void act() 
    {
        // Add your action code here.
    }    
    
    private void updateImage(){
        GreenfootImage img = new GreenfootImage(12,103);
        img.setColor(Color.BLACK);
        img.fill();
        for(int i=0;i<max_cap;i++){
            int percent = (current)*100/max_cap;
            int color_percent = (current-i)*100/max_cap;
            if(color_percent<=0){
                img.setColor(Color.BLACK);
            }
            else{
                img.setColor(new Color(255*color_percent/100,255*(100-color_percent)/100,0));
            }
            img.fillRect(1,1+(i*100/max_cap),10,1*100/max_cap+1);
        } 
        img.mirrorVertically();
        setImage(img);
    }
}
