import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class ScoreCounter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ScoreCounter  extends Actor
{
    /**
     * Act - do whatever the ScoreCounter wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private int score;
    private int act_score;
    
    public ScoreCounter(){
        score=0;
        act_score=0;
        setImage(new GreenfootImage(100,20));
        updateImage();
    }
    
    public void act() 
    {
        if(score>act_score){
            act_score+=1;
            updateImage();
        }
        else if(score<act_score){
            act_score-=1;
            updateImage();
        }
    }
    
    public void addScore(int add){
        score+=add;
    }
    
    public int getScore(){
        return score;
    }
    
    private void updateImage(){
        GreenfootImage img = new GreenfootImage(100,20);
        img.clear();
        
        img.setFont(new java.awt.Font("Comic Sans MS", java.awt.Font.BOLD, 16));
        img.setColor(new Color(0,0,0));
        img.drawString("Score:"+act_score,0,18);
        img.drawString("Score:"+act_score,1,17);
        img.setColor(new Color(255,255,255));
        img.drawString("Score:"+act_score,0,17);
        setImage(img);
    }
}
