import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class SimGuy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SimGuy  extends Actor
{
    private static final GreenfootImage SSDR = new GreenfootImage("SimStandDR.png");
    private static final GreenfootImage SSDL = new GreenfootImage("SimStandDL.png");
    private static final GreenfootImage SSUR = new GreenfootImage("SimStandUR.png");
    private static final GreenfootImage SSUL = new GreenfootImage("SimStandUL.png");
    private static final GreenfootImage SWDR1 = new GreenfootImage("SimWalkDR1.png");
    private static final GreenfootImage SWDL1 = new GreenfootImage("SimWalkDL1.png");
    private static final GreenfootImage SWUR1 = new GreenfootImage("SimWalkUR1.png");
    private static final GreenfootImage SWUL1 = new GreenfootImage("SimWalkUL1.png");
    private static final GreenfootImage SWDR2 = new GreenfootImage("SimWalkDR2.png");
    private static final GreenfootImage SWDL2 = new GreenfootImage("SimWalkDL2.png");
    private static final GreenfootImage SWUR2 = new GreenfootImage("SimWalkUR2.png");
    private static final GreenfootImage SWUL2 = new GreenfootImage("SimWalkUL2.png");
    private static final GreenfootImage sSSDR = new GreenfootImage("small/SimStandDR.png");
    private static final GreenfootImage sSSDL = new GreenfootImage("small/SimStandDL.png");
    private static final GreenfootImage sSSUR = new GreenfootImage("small/SimStandUR.png");
    private static final GreenfootImage sSSUL = new GreenfootImage("small/SimStandUL.png");
    private static final GreenfootImage sSWDR1 = new GreenfootImage("small/SimWalkDR1.png");
    private static final GreenfootImage sSWDL1 = new GreenfootImage("small/SimWalkDL1.png");
    private static final GreenfootImage sSWUR1 = new GreenfootImage("small/SimWalkUR1.png");
    private static final GreenfootImage sSWUL1 = new GreenfootImage("small/SimWalkUL1.png");
    private static final GreenfootImage sSWDR2 = new GreenfootImage("small/SimWalkDR2.png");
    private static final GreenfootImage sSWDL2 = new GreenfootImage("small/SimWalkDL2.png");
    private static final GreenfootImage sSWUR2 = new GreenfootImage("small/SimWalkUR2.png");
    private static final GreenfootImage sSWUL2 = new GreenfootImage("small/SimWalkUL2.png");
    
    public static final int NORTH=0;
    public static final int EAST=1;
    public static final int SOUTH=2;
    public static final int WEST=3;

    public static final int GRASS=0;
    public static final int LRSTRAIGHT=1;
    public static final int RLSTRAIGHT=2;
    public static final int FOURWAY=3;
    public static final int TURND=4;
    public static final int TURNL=5;
    public static final int TURNU=6;
    public static final int TURNR=7;
    public static final int THREEWAYDR=8;
    public static final int THREEWAYDL=9;
    public static final int THREEWAYUR=10;
    public static final int THREEWAYUL=11;
    /**
     * Act - do whatever the SimGuy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private int timer=0;
    private int x_off,y_off,x_cell,y_cell;
    private int direct;
    private int speed=0;
    private boolean turn=true;
    private World world=null;
    private int litter_meter=0;
    
    protected void addedToWorld(World w){
        int x_pos = Park.x_offset*Park.convert_CONS + w.getWidth()/2+getCellX()*25*Park.convert_CONS-getCellY()*25*Park.convert_CONS+getOffX()*2*Park.convert_CONS-getOffY()*2*Park.convert_CONS;
        int y_pos = Park.y_offset*Park.convert_CONS + (14*Park.convert_CONS+12*Park.convert_CONS*(getCellX())+12*Park.convert_CONS*(getCellY())+getOffX()*Park.convert_CONS+getOffY()*Park.convert_CONS);
        setLocation(x_pos,y_pos);
        world=w;
    }
    public SimGuy(int x, int y){
        this(x,y, EAST, 3, null);
    }
    public SimGuy(int x,int y, int dir, int s, World w){
        x_off=0;
        y_off=0;
        direct=dir;
        x_cell=x;
        y_cell=y;
        speed=s;
        world=w;
        animate();
    }
    
    public void act() 
    {
        if(x_off==0&&y_off==0){
            Actor[] array = ((Park)world).getObjectsAtCell(Object.class,x_cell,y_cell);
            if(array!=null){
                for(Actor a : array){
                    if(a!=null){
                        if(((Object)a).getType()==2){
                            litter_meter=0;
                        }
                    }
                }
            }
            path();
            if(litter_meter>=24-Park.level&&Greenfoot.getRandomNumber(100)<=(Park.level)&&timer%(speed*2)==0){
                litter();
                litter_meter=0;
            }
        }
        animate();
        if(timer%(speed*2)==0){
            move();
            litter_meter++;
            turn=true;
        }
        if(timer>=speed*8){
            timer=0;
        }
        
    } 
    
    private void path(){
        if(((Park)world).timer.getTimeLeft()>0){
            if(turn){
                newDir();
                turn=false;
            }
        }
        else{
            if(turn){
                Spawn s = ((Park)world).spawn;
                pathTo(s.getXCell(),s.getYCell());
                turn=false;
            }
        }
    }
    
    private int flipDir(){
        switch(direct){
            case NORTH: return SOUTH;
            case SOUTH: return NORTH;
            case WEST: return EAST;
            case EAST: return WEST;
            default: return NORTH;
        }
    }
    
    private void pathTo(int x,int y){
        int x_sep=x-x_cell;
        int y_sep=y-y_cell;
        if(x_sep==0){
            if(y_sep==0){
                ((Park)world).removeObjectCell(this);
                if(getWorld()!=null){
                    getWorld().removeObject(this);
                }
            }
            else if(y_sep<0){
                if(canMove(NORTH)){
                    turn(NORTH);
                }
                else if(canMove(WEST)){
                    turn(WEST);
                }
                else if(canMove(EAST)){
                    turn(EAST);
                }
                else{
                    turn(NORTH);
                }
            }
            else if(y_sep>0){
                if(canMove(SOUTH)){
                    turn(SOUTH);
                }
                else if(canMove(WEST)){
                    turn(WEST);
                }
                else if(canMove(EAST)){
                    turn(EAST);
                }
                else{
                    turn(NORTH);
                }
            }
        }
        else if(x_sep>0){
            if(y_sep==0){
                if(canMove(EAST)){
                    turn(EAST);
                }
                else if(canMove(NORTH)){
                    turn(NORTH);
                }
                else if(canMove(SOUTH)){
                    turn(SOUTH);
                }
                else{
                    turn(WEST);
                }
            }
            else if(y_sep<0){
                if(canMove(EAST)){
                    turn(EAST);
                }
                else if(canMove(SOUTH)){
                    turn(SOUTH);
                }
                else if(canMove(NORTH)){
                    turn(NORTH);
                }
                else{
                    turn(WEST);
                }
            }
            else if(y_sep>0){
                if(canMove(EAST)){
                    turn(EAST);
                }
                else if(canMove(NORTH)){
                    turn(NORTH);
                }
                else if(canMove(SOUTH)){
                    turn(SOUTH);
                }
                else{
                    turn(WEST);
                }
            }
        }
        else if(x_sep<0){
            if(y_sep==0){
                if(canMove(WEST)){
                    turn(WEST);
                }
                else if(canMove(NORTH)){
                    turn(NORTH);
                }
                else if(canMove(SOUTH)){
                    turn(SOUTH);
                }
                else{
                    turn(EAST);
                }
            }
            else if(y_sep<0){
                if(canMove(WEST)){
                    turn(WEST);
                }
                else if(canMove(SOUTH)){
                    turn(SOUTH);
                }
                else if(canMove(NORTH)){
                    turn(NORTH);
                }
                else{
                    turn(EAST);
                }
            }
            else if(y_sep>0){
                if(canMove(WEST)){
                    turn(WEST);
                }
                else if(canMove(NORTH)){
                    turn(NORTH);
                }
                else if(canMove(SOUTH)){
                    turn(SOUTH);
                }
                else{
                    turn(EAST);
                }
            }
        }
    }
    
    private void newDir(){
        int flip = flipDir();
        int dir = direct;
        int error = 0;
        boolean loop = true;
        while((direct==flip||direct==-1||loop)&&error<100){
            loop=false;
            error++;
            switch(dir){//case for the direction the object is going
                case NORTH:
                switch(Greenfoot.getRandomNumber(3)){//pick a new direction to travel
                    case 0:
                        turn(NORTH);
                        break;
                    case 1:
                        turn(EAST);
                        break;
                    case 2:
                        turn(WEST);
                        break;
                }                
                break;
                case SOUTH:
                switch(Greenfoot.getRandomNumber(3)){//pick a new direction to travel
                    case 0:
                        turn(SOUTH);
                        break;
                    case 1:
                        turn(EAST);
                        break;
                    case 2:
                        turn(WEST);
                        break;
                }
                break;
                case EAST:
                switch(Greenfoot.getRandomNumber(3)){//pick a new direction to travel
                    case 0:
                        turn(EAST);
                        break;
                    case 1:
                        turn(NORTH);
                        break;
                    case 2:
                        turn(SOUTH);
                        break;
                }
                break;
                case WEST:
                switch(Greenfoot.getRandomNumber(3)){//pick a new direction to travel
                    case 0:
                        turn(WEST);
                        break;
                    case 1:
                        turn(NORTH);
                        break;
                    case 2:
                        turn(SOUTH);
                        break;
                }
                break;
            }
            
        }
        if(error>90){
            turn(flip);
        }
    }
    
    private void turn(int dir){
        if(canMove(dir)){
            direct=dir;
        }
        else{
            direct=-1;
        }
    }
    
    private boolean canMove(int dir){
        Tile tile = ((Park)world).getTile(x_cell,y_cell,dir);
        if(tile==null){
            return false;
        }
        switch(dir){
            case NORTH:
                switch(tile.getType()){
                    case 1:
                    case 3:
                    case 4:
                    case 5:
                    case 8:
                    case 9:
                    case 11:
                        return true;
                    default:
                        return false;                    
                }
            case SOUTH:
                switch(tile.getType()){
                    case 1:
                    case 3:
                    case 6:
                    case 7:
                    case 8:
                    case 10:
                    case 11:
                        return true;
                    default:
                        return false;                    
                }
            case WEST:
                switch(tile.getType()){
                    case 2:
                    case 3:
                    case 4:
                    case 7:
                    case 8:
                    case 10:
                    case 9:
                        return true;
                    default:
                        return false;                    
                }
            case EAST:
                switch(tile.getType()){
                    case 2:
                    case 3:
                    case 5:
                    case 6:
                    case 11:
                    case 10:
                    case 9:
                        return true;
                    default:
                        return false;                    
                }
            default: return false;
        }
    }
    
    private void move(){
        switch(direct){
            case NORTH:
                y_off--;
                break;
            case EAST:
                x_off++;
                break;
            case SOUTH:
                y_off++;
                break;
            case WEST:
                x_off--;
                break;
        }
        if(x_off>5){
            x_off=-6;
            ((Park)world).setCell(this, getCellX()+1,getCellY());
        }
        else if(x_off<-5){
            x_off=6;
            ((Park)world).setCell(this, getCellX()-1,getCellY());
        }
        else if(y_off>5){
            y_off=-6;
            ((Park)world).setCell(this, getCellX(),getCellY()+1);
        }
        else if(y_off<-5){
            y_off=6;
            ((Park)world).setCell(this, getCellX(),getCellY()-1);
        }
        if(getWorld()!=null){
            setLocation(Park.x_offset*Park.convert_CONS + world.getWidth()/2 +x_cell*25*Park.convert_CONS-y_cell*25*Park.convert_CONS+x_off*2*Park.convert_CONS-y_off*2*Park.convert_CONS,
            Park.y_offset*Park.convert_CONS + 14*Park.convert_CONS+12*Park.convert_CONS*x_cell+12*Park.convert_CONS*y_cell+x_off*Park.convert_CONS+y_off*Park.convert_CONS);
        }
    
    }
    
    private void animate(){
        timer++;
       if(timer>=speed*8){
           switch(direct){
               case NORTH: if(Park.path_CONS=="big"){setImage(SSUR);}
                           else{setImage(sSSUR);}break;
               case EAST: if(Park.path_CONS=="big"){setImage(SSDR);}
                           else{setImage(sSSDR);}break;
               case SOUTH: if(Park.path_CONS=="big"){setImage(SSDL);}
                           else{setImage(sSSDL);}break;
               case WEST: if(Park.path_CONS=="big"){setImage(SSUL);}
                           else{setImage(sSSUL);}break;
            }
          
       }
       else if(timer>=speed*6){
           switch(direct){
               case NORTH: if(Park.path_CONS=="big"){setImage(SWUR1);}
                           else{setImage(sSWUR1);}break;
               case EAST: if(Park.path_CONS=="big"){setImage(SWDR1);}
                           else{setImage(sSWDR1);}break;
               case SOUTH: if(Park.path_CONS=="big"){setImage(SWDL1);}
                           else{setImage(sSWDL1);}break;
               case WEST: if(Park.path_CONS=="big"){setImage(SWUL1);}
                           else{setImage(sSWUL1);}break;
            }
       }
       else if(timer>=speed*4){
           switch(direct){
               case NORTH: if(Park.path_CONS=="big"){setImage(SSUR);}
                           else{setImage(sSSUR);}break;
               case EAST: if(Park.path_CONS=="big"){setImage(SSDR);}
                           else{setImage(sSSDR);}break;
               case SOUTH: if(Park.path_CONS=="big"){setImage(SSDL);}
                           else{setImage(sSSDL);}break;
               case WEST: if(Park.path_CONS=="big"){setImage(SSUL);}
                           else{setImage(sSSUL);}break;
            }
       }
       else if(timer>=speed*2){
           switch(direct){
               case NORTH: if(Park.path_CONS=="big"){setImage(SWUR2);}
                           else{setImage(sSWUR2);}break;
               case EAST: if(Park.path_CONS=="big"){setImage(SWDR2);}
                           else{setImage(sSWDR2);}break;
               case SOUTH: if(Park.path_CONS=="big"){setImage(SWDL2);}
                           else{setImage(sSWDL2);}break;
               case WEST: if(Park.path_CONS=="big"){setImage(SWUL2);}
                           else{setImage(sSWUL2);}break;
            }
       }
       else if(timer>=0){
           switch(direct){
               case NORTH: if(Park.path_CONS=="big"){setImage(SSUR);}
                           else{setImage(sSSUR);}break;
               case EAST: if(Park.path_CONS=="big"){setImage(SSDR);}
                           else{setImage(sSSDR);}break;
               case SOUTH: if(Park.path_CONS=="big"){setImage(SSDL);}
                           else{setImage(sSSDL);}break;
               case WEST: if(Park.path_CONS=="big"){setImage(SSUL);}
                           else{setImage(sSSUL);}break;
            }
           
       }
    }
    
    private void litter(){
        ((Park)world).addNewObject(new Object(Greenfoot.getRandomNumber(6)+3),getCellX(),getCellY());
    }
    
    public int getCellX(){
        return x_cell;
    }
    
    public int getCellY(){
        return y_cell;
    }
    
    public int getOffX(){
        return x_off;
    }
    
    public int getOffY(){
        return y_off;
    }
    
    public void setCellX(int x){
        x_cell = x;
    }
    
    public void setCellY(int y){
        y_cell = y;
    }
}
