import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Park here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Park extends World
{
    public static final GreenfootImage grass=new GreenfootImage("Grass.png");
    public static final GreenfootImage tlrs=new GreenfootImage("Tile_left_to_right.png");
    public static final GreenfootImage trls=new GreenfootImage("Tile_right_to_left.png");
    public static final GreenfootImage fway=new GreenfootImage("Tile_4_way.png");
    public static final GreenfootImage turnd=new GreenfootImage("Tile_turn_1.png");
    public static final GreenfootImage turnl=new GreenfootImage("Tile_turn_2.png");
    public static final GreenfootImage turnu=new GreenfootImage("Tile_turn_3.png");
    public static final GreenfootImage turnr=new GreenfootImage("Tile_turn_4.png");
    public static final GreenfootImage twdr=new GreenfootImage("Tile_3_way_dright.png");
    public static final GreenfootImage twdl=new GreenfootImage("Tile_3_way_dleft.png");
    public static final GreenfootImage twur=new GreenfootImage("Tile_3_way_uright.png");
    public static final GreenfootImage twul=new GreenfootImage("Tile_3_way_uleft.png");

    public static final GreenfootImage sgrass=new GreenfootImage("small/Grass.png");
    public static final GreenfootImage stlrs=new GreenfootImage("small/Tile_left_to_right.png");
    public static final GreenfootImage strls=new GreenfootImage("small/Tile_right_to_left.png");
    public static final GreenfootImage sfway=new GreenfootImage("small/Tile_4_way.png");
    public static final GreenfootImage sturnd=new GreenfootImage("small/Tile_turn_1.png");
    public static final GreenfootImage sturnl=new GreenfootImage("small/Tile_turn_2.png");
    public static final GreenfootImage sturnu=new GreenfootImage("small/Tile_turn_3.png");
    public static final GreenfootImage sturnr=new GreenfootImage("small/Tile_turn_4.png");
    public static final GreenfootImage stwdr=new GreenfootImage("small/Tile_3_way_dright.png");
    public static final GreenfootImage stwdl=new GreenfootImage("small/Tile_3_way_dleft.png");
    public static final GreenfootImage stwur=new GreenfootImage("small/Tile_3_way_uright.png");
    public static final GreenfootImage stwul=new GreenfootImage("small/Tile_3_way_uleft.png");

    public static int convert_CONS=1;
    public static int x_offset=0;
    public static int y_offset=0;
    public static String path_CONS="small";

    public static final int NORTH=0;
    public static final int EAST=1;
    public static final int SOUTH=2;
    public static final int WEST=3;
    
    public static final Actor[] EMPTY_ACTOR_ARRAY=new Actor[0];
    public static final int GRASS=0;
    public static final int LRSTRAIGHT=1;
    public static final int RLSTRAIGHT=2;
    public static final int FOURWAY=3;
    public static final int TURND=4;
    public static final int TURNL=5;
    public static final int TURNU=6;
    public static final int TURNR=7;
    public static final int THREEWAYDR=8;
    public static final int THREEWAYDL=9;
    public static final int THREEWAYUR=10;
    public static final int THREEWAYUL=11;
    
    private boolean need_redraw=false;
    /**
     * Constructor for objects of class Park.
     * 
     */
    public static int level=0;
    public static int cans=1;
    public int daytimer=0;
    public Meter meter = new Meter(100);
    public Timer timer = new Timer(3600);
    public ScoreCounter score=new ScoreCounter();
    public Spawn spawn=new Spawn(4,9,this);
    private int map_x_size=10;
    private int map_y_size=10;
    public Actor[][][] map ={{{new Tile(4)},{new Tile(2)},{new Tile(2)},{new Tile(2)},{new Tile(9)},{new Tile(2)},{new Tile(2)},{new Tile(2)},{new Tile(2)},{new Tile(5)}},
                             {{new Tile(1)},{new Tile(0)},{new Tile(0)},{new Tile(0)},{new Tile(1)},{new Tile(0), new Object(9)},{new Tile(0)},{new Tile(0)},{new Tile(0), new Object(1)},{new Tile(1)}},
                             {{new Tile(1)},{new Tile(0)},{new Tile(0)},{new Tile(0), new Object(1)},{new Tile(1)},{new Tile(0)},{new Tile(0)},{new Tile(0)},{new Tile(0)},{new Tile(1)}},
                             {{new Tile(1)},{new Tile(0), new Object(9)},{new Tile(0)},{new Tile(0)},{new Tile(1)},{new Tile(0)},{new Tile(0)},{new Tile(0)},{new Tile(0)},{new Tile(1)}},
                             {{new Tile(1)},{new Tile(0)},{new Tile(0)},{new Tile(0), new Object(1)},{new Tile(1)},{new Tile(0),new Object(9)},{new Tile(0)},{new Tile(0), new Object(1)},{new Tile(0)},{new Tile(1)}},
                             {{new Tile(8)},{new Tile(2)},{new Tile(2)},{new Tile(2)},{new Tile(3)},{new Tile(2)},{new Tile(2)},{new Tile(2)},{new Tile(2)},{new Tile(11)}},
                             {{new Tile(1)},{new Tile(0)},{new Tile(0)},{new Tile(0),new Object(9)},{new Tile(1)},{new Tile(0),new Object(9)},{new Tile(0)},{new Tile(0)},{new Tile(0)},{new Tile(1)}},
                             {{new Tile(1)},{new Tile(0)},{new Tile(0),new Object(1)},{new Tile(0)},{new Tile(1)},{new Tile(0)},{new Tile(0)},{new Tile(0)},{new Tile(0)},{new Tile(1)}},
                             {{new Tile(1)},{new Tile(0)},{new Tile(0), new Object(9)},{new Tile(0)},{new Tile(1)},{new Tile(0)},{new Tile(0)},{new Tile(0), new Object(1)},{new Tile(0)},{new Tile(1)}},
                             {{new Tile(7)},{new Tile(2)},{new Tile(2)},{new Tile(2)},{new Tile(3), spawn},{new Tile(2)},{new Tile(2)},{new Tile(2)},{new Tile(2)},{new Tile(6)}}};
    public Park()
    {    
        // Create a new world with 20x20 cells with a cell size of 10x10 pixels.
        super(500, 250, 1);
        setPaintOrder(Meter.class, Text.class,Timer.class,ScoreCounter.class,Trashcan.class,Spawn.class);
        setBackground("BG.png");
        draw();
        addObject(new Trashcan(),getWidth()-48,getHeight()-48);
        addObject(score,getWidth()-90,25);
        addObject(timer,60,25);
        addObject(new Text("Trash Level"),80,getHeight()-32);
        addObject(meter, 10, getHeight()-60);
        level++;
    }
    
    public void runCycle(){
        for(int y=0;y<map_y_size;y++){
            for(int x=0;x<map_x_size;x++){
                for(Actor a : map[y][x]){
                    if(a.getWorld()==null){
                        a.act();
                    }
                }
            }
        }
    }
    
    public void nextLevel(){
        String s = "";
        if(level%5==0){
            s = "Day "+level+" passed! You have earned a trashcan! Use it by clicking the trashcan button and placing it in your park!";
            cans++;
        }
        else{
            s = "Day "+level+" passed!";
        }
        timer.reset(3600+60*level);
        addObject(new MessageBox(s,false),getWidth()/2,getHeight()/2);
        level++;
    }
    
    public void act(){
        if(getObjects(MessageBox.class).size()==0){
            if(timer.getTimeLeft()==0&&getIsoObjects(SimGuy.class).length==0){
                nextLevel();                
            }
            runCycle();
            if(Greenfoot.isKeyDown("s")){
                if(y_offset*convert_CONS>-(12*map.length+12*map[0].length)/2-(convert_CONS-1)*(12*map.length+12*map[0].length)){
                    y_offset--;
                    need_redraw=true;
                }
            }
            if(Greenfoot.isKeyDown("w")){
                if(y_offset*convert_CONS<(12*map.length+12*map[0].length)/2){
                    y_offset++;
                    need_redraw=true;
                }
            }
            if(Greenfoot.isKeyDown("d")){
                if(x_offset>-getWidth()/2){
                    x_offset--;
                    need_redraw=true;
                }
            }
            if(Greenfoot.isKeyDown("a")){
                if(x_offset<getWidth()/2){
                    x_offset++;
                    need_redraw=true;
                }
            }
            
            
            
            if(Greenfoot.isKeyDown("z")&&path_CONS!="big"){
                convert_CONS=2;
                y_offset-=(12*map.length+12*map[0].length)/4;
                path_CONS="big";
                need_redraw=true;
                reDrawImages();
            }
            if(Greenfoot.isKeyDown("x")&&path_CONS!="small"){
                convert_CONS=1;
                y_offset+=(12*map.length+12*map[0].length)/4;
                path_CONS="small";
                need_redraw=true;
                reDrawImages();
            }
            
            if(need_redraw){
                reDraw();
                
                need_redraw=false;
            }
            
            if(Greenfoot.mousePressed(null)){
                MouseInfo mouse = Greenfoot.getMouseInfo();
                Actor[] array = getObjectsAtTile(Object.class,mouse.getX(),mouse.getY());
                for(Actor a : array){
                    if(a!=null){
                        Object obj = (Object)a;
                        obj.grab();
                        obj.drag_x=mouse.getX();
                        obj.drag_y=mouse.getY();
                    }
                }
            }
            if(Greenfoot.mouseClicked(null)||Greenfoot.mouseDragEnded(null)){
                for(java.lang.Object o : getObjects(Object.class)){
                    Object obj = (Object)o;
                    if(obj.getType()==1){
                        obj.release();
                    }
                }
            }
            int trashCount=0;
            for(java.lang.Object o : getIsoObjects(Object.class)){
                if(((Object)o).getType()==1){
                    trashCount++;
                }
                
            }
            meter.updateCurrent(trashCount);
            if(meter.maxed()){
                Greenfoot.stop();
                addObject(new MessageBox("You have allowed too much trash to accumulate in your park! Trash is  not good for the environment!",true), getWidth()/2, getHeight()/2);
            }
        }
    }
    private void reDrawImages(){
        for(int y=0;y<map.length;y++){
            for(int x=0;x<map[0].length;x++){
                for(Actor a : map[y][x]){
                    if(a.getClass()==Tile.class){
                        Tile t = (Tile)a;
                        t.refresh();
                    }
                    else if(a.getClass()==Object.class){
                        Object t = (Object)a;
                        t.refresh();
                    }
                    else if(a.getClass()==Spawn.class){
                        Spawn t = (Spawn)a;
                        t.refresh();
                    }
                }
            }
        }
    }
    public void removeObjectCell(Actor obj){
        for(int y=0;y<map.length;y++){
            for(int x=0;x<map[0].length;x++){
                for(Actor a : map[y][x]){
                    if(a==obj){
                        List<Actor> list = new ArrayList<Actor>(Arrays.asList(map[y][x]));
                        list.removeAll(Arrays.asList(obj));
                        map[y][x] = list.toArray(EMPTY_ACTOR_ARRAY);  
                    }
                }
            }
        }
    }
    
    public void setCell(SimGuy obj, int x, int y){
        List<Actor> list = new ArrayList<Actor>(Arrays.asList(map[obj.getCellY()][obj.getCellX()]));
        list.removeAll(Arrays.asList(obj));
        map[obj.getCellY()][obj.getCellX()] = list.toArray(EMPTY_ACTOR_ARRAY);
        list = new ArrayList<Actor>(Arrays.asList(map[y][x]));
        list.addAll(Arrays.asList(obj));
        map[y][x] = (Actor[]) list.toArray(EMPTY_ACTOR_ARRAY);
        obj.setCellX(x);
        obj.setCellY(y);
        need_redraw=true;
    }
    
    public java.lang.Object[] getIsoObjects(Class clss){
        java.lang.Object[] array;
        List<Actor> list = new ArrayList<Actor>();
        list.clear();
        for(int y=0;y<map.length;y++){
            for(int x=0;x<map[0].length;x++){
                for(Actor a : map[y][x]){
                    //array = new Actor[map[y_cell][x_cell].length];
                    //int i=0;
                    if(a.getClass()==clss){
                        list.add(a);
                    }
                }
            }
        }
        array=list.toArray();
        return array;
    }
    
    public int getTileX(int x_pix, int y_pix){
        x_pix-=x_offset*convert_CONS;
        y_pix-=y_offset*convert_CONS;
        int x_cell = (int) Math.floor((((double)x_pix+25*convert_CONS-((double)getWidth())/2)/(50*convert_CONS))+(((double)y_pix-12*convert_CONS)/(24*convert_CONS)));
        if(x_cell>=0&&x_cell<map[0].length){ 
            return x_cell;
        }
        else{
            return -1;
        }
    }
    
    public int getTileY(int x_pix, int y_pix){
        x_pix-=x_offset*convert_CONS;
        y_pix-=y_offset*convert_CONS;
        int y_cell = (int) Math.floor((((double)y_pix+12*convert_CONS)/(24*convert_CONS))-(((double)x_pix+25*convert_CONS-((double)getWidth())/2)/(50*convert_CONS)));
        if(y_cell>=0&&y_cell<map.length){ 
            return y_cell;
        }
        else{
            return -1;
        }
    }
    
    public Actor[] getObjectsAtCell(Class clss, int x_cell, int y_cell){
        Actor[] array;
        if(y_cell>=0&&y_cell<map.length && x_cell>=0&&x_cell<=map[0].length){
            array = new Actor[map[y_cell][x_cell].length];
            int i=0;
            for(Actor a : map[y_cell][x_cell]){
                if(a.getClass()==clss){
                    array[i]=a;
                    i++;
                }
            }
        }
        else{
            array = new Actor[1];
            array[0] = null;
        }
        return array;
    }
    
    public Actor[] getObjectsAtTile(Class clss, int x_pix, int y_pix){
        Actor[] array;
        x_pix-=x_offset*convert_CONS;
        y_pix-=y_offset*convert_CONS;
        int x_cell = (int) Math.floor((((double)x_pix+25*convert_CONS-((double)getWidth())/2)/(50*convert_CONS))+(((double)y_pix-12*convert_CONS)/(24*convert_CONS)));
        int y_cell = (int) Math.floor((((double)y_pix+12*convert_CONS)/(24*convert_CONS))-(((double)x_pix+25*convert_CONS-((double)getWidth())/2)/(50*convert_CONS)));
        if(y_cell>=0&&y_cell<map.length && x_cell>=0&&x_cell<map[0].length){
            array = new Actor[map[y_cell][x_cell].length];
            int i=0;
            for(Actor a : map[y_cell][x_cell]){
                if(a.getClass()==clss){
                    array[i]=a;
                    i++;
                }
            }
            
            
            
        }
        else{
            array = new Actor[1];
            array[0] = null;
        }
        return array;
    }
    
    public void addNewObject(Object obj, int x, int y){
        List<Actor> list = new ArrayList<Actor>(Arrays.asList(map[y][x]));
        list.addAll(Arrays.asList(obj));
        map[y][x] = (Actor[]) list.toArray(EMPTY_ACTOR_ARRAY);
        need_redraw=true;
    }
    
    public Tile getTile(int x, int y, int dir){
        try{
            switch(dir){
                case NORTH: return (Tile)map[y-1][x][0];
                case SOUTH: return (Tile)map[y+1][x][0];
                case EAST: return (Tile)map[y][x+1][0];
                case WEST: return (Tile)map[y][x-1][0];
                default: return null;
            }
        }
        catch(java.lang.ArrayIndexOutOfBoundsException e){
            return null;
        }
    }
    
    private void reDraw(){
        java.util.List list = getObjects(Actor.class);
        list.removeAll(getObjects(Trashcan.class));
        list.removeAll(getObjects(ScoreCounter.class));
        list.removeAll(getObjects(Timer.class));
        list.removeAll(getObjects(Text.class));
        list.removeAll(getObjects(Meter.class));
        removeObjects(list);
        draw();
    }
    
    private void draw(){
        for(int y=0;y<map_y_size;y++){
            for(int x=0;x<map_x_size;x++){
                for(Actor a : map[y][x]){
                    //try{
                    //    SimGuy guy = (SimGuy)a;
                    //    int x_pos = getWidth()/2+guy.getCellX()*25-guy.getCellY()*25+guy.getOffX()*2-guy.getOffY()*2;
                    //    int y_pos = (14+12*(guy.getCellX())+12*(guy.getCellY())+guy.getOffX()+guy.getOffY());
                        //addObject(guy,x_pos,y_pos);
                    //}
                    //catch(Exception e){
                        int x_pos=getWidth()/2 +x*25*convert_CONS-y*25*convert_CONS + x_offset*convert_CONS;
                        int y_pos=14*convert_CONS+12*x*convert_CONS+12*y*convert_CONS + y_offset*convert_CONS;
                        if(x_pos<=getWidth()&&x_pos>=0&&y_pos<=getHeight()&&y_pos>=0){
                            addObject(a,x_pos,y_pos);
                        }
                    //}
                }
            }
        }
        
    }
}
